README:

Algunos supuestos y consideraciones tomados al desarrollar los programas:
- La ip y el número de puerto es fijo, por lo que si se quiere cambiar de broker se tendrá que modificar la ip directamente desde el programa.
- El tiempo en que se midió el uso de memoria, cpu y datos enviados por la red fue de alrededor de 1 hora, ambos programas fueron ejecutados al mismo tiempo.

Acerca de la estructura de archivos y carpetas:
Cada carpeta contiene los archivos de un sensor en específico, los cuales son el acelerómetro, el sensor ultrasónico y la cámara.
La carpeta ejemplos fue usada para almacenar programas que pueden servir como referencia para el uso de sensores o de envio de datos por MQTT.
Por último tenemos la carpeta de mediciones, el cual contiene subcarpetas respectivas a los sensores, y estas contienen dos archivos, 
"mem.txt" donde está la información del uso de memoria y procesador. y "net.txt" donde está la información sobre la cantidad de datos enviados.
Excluyendo las carpetas y este archivo README, hay 5 archivos extra, 3 de ellos son los archivos usados por parte del broker para recibir la información, los cuales son "subscriberacel.py", "subscribercamara.py", y ""subscribersonico.py".
El otro archivo es una lista de comandos usados para la realización de estas mediciones, y por último tenemos un archivo word el cual es una copia de seguridad del documento de mi memoria hasta la fecha.

Acerca de los archivos para usar el Acelerómetro:
Tódo el codigo que controla el acelerómetro se encuentra en el archivo "Acel.py", este programa toma una muestra cada 0.001 segundos, y las almacena en una lista, al juntar 1000 muestras el programa usa el filtro de mediana y un filtro pasa bajos para reducir el error en las mediciones, posteriormente el programa envía las 1000 muestras a su destino.

Acerca de los archivos para usar la cámara:
Antes de correr el programa se debe ejecutar el comando por bash "sudo modprobe bcm2835-v4l2".
Para iniciar el programa se debe iniciar "NewMain.py"
Lo que hace el programa es grabar por medio de la cámara, para luego capturar los frames y analizarlos con PCA para obtener de la imagen todos los contornos que encuentre, por cada contorno encontrado se sacan los vectores y valores propios para finalmente enviarlos.

Acerca de los archivos para usar el sensor ultrasónico:
Tódo el codigo que controla el sensor ultrasónico se encuentra en el archivo "publisher.py", este programa toma una muestra cada 0.01 segundo en donde el sensor emite una onda ultrasónica para luevo recibir esta señal de vuelta y así poder calcular la distancia que este se encuentre de un objeto, para mayor precisión, esta señal se hace pasar por el filtro de kalman. Después de obtener la señal filtrada, se envía al receptor.
Algo importante a destacar de este programa es que ignora todas las señales que superen el límite de percepción del sensor, ya que provocan un malfuncionamiento en el filtro de kalman, dichas señales superan por 3 o más en orden de magnitud.

Acerca de los archivos de medición de memoria:
Para medir la memoria usada del programa se ocupó la siguiente instrucción:
"for i in {1..60}; do sleep 60 && top -b -n1 | grep python3 | tail -1 ; done >> mem.txt" (A veces se cambió "grep python3" por "grep python")
Lo que nos permite obtener el uso de CPU y memoria.
Los datos de cada columna son los siguientes:
PID USER PR NI VIRT RES SHR S %CPU %MEM TIME+ COMMAND


PID: Muestra la id del proceso
PR: Es la prioridad de la tarea
SHR: Cantidad de memoria compartida
VIRT: Memoria virtual usada
USER: Nombre de usuario del dueño de la tarea
%CPU: Uso de CPU
TIME+: Tiempo de CPU
SHR: Representa el tamaño de memoria compartida (kb) usada por la tarea.
NI: Representa un "Nice Value" de la tarea. Un valor negativo de nice value implica mayor prioridad.
%MEM: Muestra el uso de memoria de la tarea.

Acerca de los archivos de medición de red:
Para medir la cantidad de datos enviados se usó la siguiente instrucción:
for i in {1..60}; do sudo iftop -i eth0 -f "dst port 1883" -t -s 60 | grep "=>" ; done > net.txt
La que nos permite obtener el volumen de datos enviados.
Las columnas que podemos ver son:
IP "Last 2s" "Last 10s" "Last 40s" Cumulative
En donde el valor de Cumulative es el importante para obtener las mediciones.






