from Worker import *
from VideoObjects import *

import multiprocessing
from multiprocessing import Queue, Pool

import time

def vectorToString(arr):
    word = "[\n"
    for cont in arr:
        word = word + "mean: ("
        x,y = cont['mean'].shape
        for i in range(x):
            word = word + str(cont['mean'][0][i])
            if i < (x-1):
                word = word + ", "
        word = word + ")\n"
        x,y = cont['EVec'].shape
        word = word + "Eigenvectors: ["
        for j in range(y):
            word = word + "["
            for i in range(x):
                word = word + str(cont['EVec'][j][i])
                if i < (x-1):
                    word = word + ", "
            if j < (y-1):
                word = word + "]\n"
        word = word + "]]\n"
        x,y = cont['EVal'].shape
        word = word + "Eigenvalues: ("
        for j in range(y):
            word = word + str(cont['mean'][j][0])
            if j < (y-1):
                word = word + ", "
        word = word + ")\n"
        word = word + "]\n"
    #print(word)
    return word



def realtime(args,client1):
    input_q = Queue(maxsize=args["queue_size"])
    output_q = Queue(maxsize=args["queue_size"])
    pool = Pool(args["num_workers"], worker, (input_q, output_q))

    vs = WebcamVideoStream().start()
    #fps = FPS().start()

    print("Starting video acquisition. Press 'Ctrl+C' to stop.")
    start_time = time.time()
    counterpackets = 0
    #countFrame = 0
    try:
        while True:
            ret, frame = vs.read()
            #countFrame = countFrame + 1
            if ret:
                #print(input_q.qsize())
                time.sleep(0.01)
                if(input_q.full()):
                    continue
                input_q.put(frame)
                output_vector = output_q.get()
                #ret = client1.publish("Camera", vectorToString(output_vector))
                counterpackets += 1
                ret = client1.publish("Camera", vectorToString(output_vector))
                #print(countFrame)
            # Display the resulting frame
                #if countFrame >= args["num_frames"]:
                    #break
            #else:
                #break

            #if cv2.waitKey(1) & 0xFF == ord('q'):
            #    break
    except KeyboardInterrupt:
        #fps.stop()
        pool.terminate()
        cv2.destroyAllWindows()
        print("--- %s seconds ---" % (time.time() - start_time))
        print("--- %s packets ---" % (counterpackets))
