from VideoObjects import *

import multiprocessing
from multiprocessing import Queue, Pool
import numpy as np
from math import atan2, cos, sin, sqrt, pi

def getOrientation(pts):
    sz = len(pts)
    data_pts = np.empty((sz, 2), dtype=np.float64)
    for i in range(data_pts.shape[0]):
        data_pts[i,0] = pts[i,0,0]
        data_pts[i,1] = pts[i,0,1]
    # Perform PCA analysis
    mean = np.empty((0))
    mean, eigenvectors, eigenvalues = cv2.PCACompute2(data_pts, mean)
    # Store the center of the object
    cntr = (int(mean[0,0]), int(mean[0,1]))

    angle = atan2(eigenvectors[0,1], eigenvectors[0,0]) # orientation in radians
    cont = dict()
    cont['mean'] = mean
    cont['EVec'] = eigenvectors
    cont['EVal'] = eigenvalues
    cont['angle'] = angle

    return cont
    #return (mean, eigenvectors, eigenvalues, angle)

#def extract_features(image, vector_size=32):
#    try:
#        alg = cv2.KAZE_create()
#        kps = alg.detect(image)
#        kps = sorted(kps, key=lambda x: -x.response)[:vector_size]
#        kps, dsc = alg.compute(image,kps)
#        dsc = dsc.flatten()
#        needed_size = (vector_size * 64)
#        if dsc.size < needed_size:
#            dsc = np.concatenate([dsc,np.zeros(needed_size - dsc.size)])
#    except cv2.error as e:
#        #print('Error: %s', e)
#        print(e)
#        return None
#    return dsc

#def worker(input_q,output_q):
#    fps = FPS().start()
#    while True:
#        fps.update()
#        frame = input_q.get()
#        #print (frame)
#        if len(frame) == 2:
#            frame_rgb = cv2.cvtColor(frame[1], cv2.COLOR_BGR2RGB)
#            output_q.put((frame[0],extract_features(frame_rgb)))
#        else:
#            frame_rgb = cv2.cvtColor(frame, cv2.COLOR_BGR2RGB)
#            output_q.put(extract_features(frame_rgb))
#    fps.stop()

def worker(input_q,output_q):
    while(True):
        frame = input_q.get()
        # Convert image to grayscale
        if len(frame) == 2:
            gray = cv2.cvtColor(frame[1], cv2.COLOR_BGR2GRAY)
        else:
            gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)


        # Convert image to binary
        _, bw = cv2.threshold(gray, 50, 255, cv2.THRESH_BINARY | cv2.THRESH_OTSU)
        _, contours, _ = cv2.findContours(bw, cv2.RETR_LIST, cv2.CHAIN_APPROX_NONE)
        L = []
        for i, c in enumerate(contours):
            # Calculate the area of each contour
            area = cv2.contourArea(c);
            # Ignore contours that are too small or too large
            if area < 1e2 or 1e5 < area:
                continue
            # Find the orientation of each shape
            L.append(getOrientation(c))
            #output_q.put(getOrientation(c))
        output_q.put(L)
