import time #se necesita para usar las funciones de tiempo
from subprocess import call #la necesitamos para la interrupcion de teclado
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BOARD) #Queremos usar la numeracion de la placa

#Definimos los dos pines del sensor que hemos conectado: Trigger y Echo
Trig = 10
Echo = 12

#Hay que configurar ambos pines del HC-SR04
GPIO.setup(Trig, GPIO.OUT)
GPIO.setup(Echo, GPIO.IN)

print "Sensor Ultrasonico"

try:
    while True:
        GPIO.output(Trig, False) #apagamos el pin Trig
        time.sleep(0.5) #Frequencia

        GPIO.output(Trig, True) #encendemos el pin Trig
        time.sleep(0.00001)
        GPIO.output(Trig, False) #y lo volvemos a apagar
        start = time.time()

        #empezaremos a contar el tiempo cuando el pin Echo se encienda
        while GPIO.input(Echo) == 0:
            start = time.time()
        while GPIO.input(Echo) == 1:
            end = time.time()

        #Calculo de la distancia
        #Para calcular la distancia entre el sensor y el objeto
        #se usa la formula Distancia = velocidad * tiempo
        #Como la onda toma la mitad del tiempo en llegar, dividimos el resultado en 2
        #La velocidad del sonido en un medio de aire al nivel del mar es aproximadamente 34300 cm/s
        #por lo tanto multiplicamos la duración del pulso por 17150 para obtener la distancia
        duracion = end-start
        medida = duracion*17150
        print "%.2f" %medida #por ultimo, vamos a mostrar el resultado por pantalla
except KeyboardInterrupt:
    GPIO.cleanup()
