import matplotlib.pyplot as plt
import re
from datetime import datetime

def plotting_net(file):
    values = []
    file = open(file)
    for line in file:
        words = line.strip().split()
        no = int(re.findall("[0-9]+",words[6])[0])
        values.append(no)
    return values

def plotting_mem(file):
    mem_use = []
    cpu_use = []
    time_elapsed = []
    file = open(file)
    for line in file:
        words = line.strip().split()
        mem = int(re.findall("[0-9]+",words[4])[0])
        cpu = float(re.findall("[0-9]+.[0-9]+",words[8])[0])
        time = re.findall("[0-9]+:[0-9]+.[0-9]+",words[10])[0]
        min,sec = time.split(":")
        min = float(min)*60
        sec = float(sec)
        mem_use.append(mem)
        cpu_use.append(cpu)
        time_elapsed.append(min+sec)
    return (mem_use,cpu_use, time_elapsed)

def plotting_mem_cam(file):
    mem_use = []
    cpu_use = []
    time_elapsed = []
    file = open(file)
    counter = -1
    for line in file:
        words = line.strip().split()
        if(len(words)) == 1:
            if (counter != -1):
                mem_use.append(mem)
                cpu_use.append(cpu)
                time_elapsed.append(counter*60)

            mem = 0
            cpu = 0
            counter += 1
        else:
            mem += int(re.findall("[0-9]+",words[4])[0])
            cpu += float(re.findall("[0-9]+.[0-9]+",words[8])[0])
    return (mem_use,cpu_use, time_elapsed)



file = "mediciones/acelerómetro/net.txt"
y1 = plotting_net(file)
x1 = []
for i in range(len(y1)):
    x1.append((i+1)*60)

plt.plot(x1, y1, 'ro')
plt.title('Flujo de datos v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Flujo de datos [KB]')
plt.savefig('Acelerometro Red.png')
plt.clf()

file = "mediciones/acelerómetro/mem.txt"
y1, y2, x1 = plotting_mem(file)

plt.plot(x1, y1, 'b-')
plt.title('Memoria Virtual v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Memoria virtual usada [Kb]')
plt.savefig('Acelerometro memoria.png')
plt.clf()

plt.plot(x1, y2, 'g-')
plt.title('Porcentaje CPU v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Porcentaje de CPU usado')
plt.savefig('Acelerometro CPU.png')
plt.clf()








file = "mediciones/cámara/net.txt"
y1 = plotting_net(file)
x1 = []
for i in range(len(y1)):
    x1.append((i+1)*60)

plt.plot(x1, y1, 'ro')
plt.title('Flujo de datos v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Flujo de datos [KB]')
plt.savefig('cámara Red.png')
plt.clf()

file = "mediciones/cámara/mem.txt"
y1, y2, x1 = plotting_mem(file)

plt.plot(x1, y1, 'b-')
plt.title('Memoria Virtual v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Memoria virtual usada [Kb]')
plt.savefig('cámara memoria.png')
plt.clf()

plt.plot(x1, y2, 'g-')
plt.title('Porcentaje CPU v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Porcentaje de CPU usado')
plt.savefig('cámara CPU.png')
plt.clf()








file = "mediciones/ultrasonido/net.txt"
y1 = plotting_net(file)
x1 = []
for i in range(len(y1)):
    x1.append((i+1)*60)

plt.plot(x1, y1, 'ro')
plt.title('Flujo de datos v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Flujo de datos [KB]')
plt.savefig('ultrasonido Red.png')
plt.clf()

file = "mediciones/ultrasonido/mem.txt"
y1, y2, x1 = plotting_mem(file)

plt.plot(x1, y1, 'b-')
plt.title('Memoria Virtual v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Memoria virtual usada [Kb]')
plt.savefig('ultrasonido memoria.png')
plt.clf()

plt.plot(x1, y2, 'g-')
plt.title('Porcentaje CPU v/s Tiempo')
plt.xlabel('Tiempo [s]')
plt.ylabel('Porcentaje de CPU usado')
plt.savefig('ultrasonido CPU.png')
plt.clf()
