import paho.mqtt.client as mqtt #import the client1
import time
from subprocess import call

from Crypto import Random
from Crypto.PublicKey import RSA
import base64
import mysql.connector



########################################
def on_message(client, userdata, message):
    msg = str(message.payload.decode("utf-8"))
    print("message received " , msg)
    data, de, node = msg.strip().split()
    data = float(data)
    de = float(de)
    node = int(node)

    cursor = db.cursor()
    query = "INSERT INTO Aceleration (mad, se, node) VALUES (%s, %s, %s)"
    values = (data, de, node)
    cursor.execute(query, values)
    db.commit()

    print(cursor.rowcount, "record inserted")
    if(data >= 1):
        print("WARNIING! The sensor is moving")

    #print("message topic=",message.topic)
    #print("message qos=",message.qos)
    #print("message retain flag=",message.retain)

def on_connect(client, userdata, rc):
    print('Connected with result code %s' % rc)
########################################
def generate_keys():
    #Source: https://www.tutorialspoint.com/cryptography_with_python/cryptography_with_python_quick_guide.htm
    # key length must be a multiple of 256 and >= 1024
    modulus_length = 256*4
    privatekey = RSA.generate(modulus_length, Random.new().read)
    publickey = privatekey.publickey()
    return privatekey, publickey

def encrypt_message(a_message , publickey):
   encrypted_msg = publickey.encrypt(a_message, 32)[0]
   encoded_encrypted_msg = base64.b64encode(encrypted_msg)
   return encoded_encrypted_msg

def decrypt_message(encoded_encrypted_msg, privatekey):
   decoded_encrypted_msg = base64.b64decode(encoded_encrypted_msg)
   decoded_decrypted_msg = privatekey.decrypt(decoded_encrypted_msg)
   return decoded_decrypted_msg
########################################
try:
    db = mysql.connector.connect(
      host="localhost",
      user="root",
      passwd="48nyde26",
      database = "MemAcel"
    )

    broker_address = "192.168.0.21"
    client = mqtt.Client()
    client.on_connect = on_connect
    client.on_message = on_message
    client.connect(broker_address, 1883, 60)
    client.subscribe("Accelerometer")

    client.loop_forever()

except KeyboardInterrupt:
    client.disconnect()
